Index: trunk/src/VBox/Runtime/Makefile.kmk
===================================================================
--- trunk/src/VBox/Runtime/Makefile.kmk	(revision 74642)
+++ trunk/src/VBox/Runtime/Makefile.kmk	(revision 74643)
@@ -272,5 +272,7 @@
 	IPRT_WITH_OPENSSL \
 	NOFILEID
-#	+= LDR_WITH_MACHO
+ifeq ($(USERNAME),bird)
+ RuntimeR3_DEFS += LDR_WITH_MACHO
+endif
 if1of ($(KBUILD_TARGET_ARCH), amd64 x86)
  RuntimeR3_DEFS         += \
Index: trunk/src/VBox/Runtime/common/ldr/ldrLX.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/ldr/ldrLX.cpp	(revision 74642)
+++ trunk/src/VBox/Runtime/common/ldr/ldrLX.cpp	(revision 74643)
@@ -546,5 +546,4 @@
 
 
-/** @copydoc kLdrModQuerySymbol */
 static int kldrModLXQuerySymbol(PRTLDRMODINTERNAL pMod, const void *pvBits, RTLDRADDR BaseAddress, uint32_t iSymbol,
                                 const char *pchSymbol, size_t cchSymbol, const char *pszVersion,
@@ -1149,5 +1148,4 @@
 
 
-/** @copydoc kLdrModGetImport */
 static int kldrModLXGetImport(PKLDRMODLX pModLX, const void *pvBits, uint32_t iImport, char *pszName, size_t cchName,
                               size_t *pcbNeeded)
@@ -1292,5 +1290,4 @@
 
 
-/** @copydoc kLdrModHasDbgInfo */
 static int kldrModLXHasDbgInfo(PRTLDRMODINTERNAL pMod, const void *pvBits)
 {
@@ -2254,5 +2251,4 @@
                 union
                 {
-
                     const uint8_t          *pb;
                     const struct r32_rlc   *prlc;
@@ -2540,4 +2536,7 @@
  * @param   pbPage      The page in which to apply the fixup.
  * @param   off         Page relative offset of where to apply the offset.
+ * @param   PageAddress The page address.
+ * @param   prlc        The relocation record.
+ * @param   iSelector   Selector value, -1 if flat.
  * @param   uValue      The target value.
  * @param   fKind       The target kind.
Index: trunk/src/VBox/Runtime/common/ldr/ldrMachO.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/ldr/ldrMachO.cpp	(revision 74642)
+++ trunk/src/VBox/Runtime/common/ldr/ldrMachO.cpp	(revision 74643)
@@ -508,4 +508,5 @@
  * @param   pRdr            The file reader.
  * @param   offImage        The image header (FAT fun).
+ * @param   fOpenFlags      RTLDR_O_XXX.
  * @param   pcSegments      Where to store the segment count.
  * @param   pcSegments      Where to store the section count.
@@ -514,8 +515,10 @@
  * @param   pLinkAddress    Where to store the image link address (i.e. the
  *                          lowest segment address).
- */
-static int  kldrModMachOPreParseLoadCommands(uint8_t *pbLoadCommands, const mach_header_32_t *pHdr, PRTLDRREADER pRdr, RTFOFF   offImage,
-                                             uint32_t fOpenFlags, uint32_t *pcSegments, uint32_t *pcSections, uint32_t *pcbStringPool,
-                                             bool *pfCanLoad, PRTLDRADDR pLinkAddress, uint8_t *puEffFileType)
+ * @param   puEffFileType   Where to store the effective file type.
+ */
+static int kldrModMachOPreParseLoadCommands(uint8_t *pbLoadCommands, const mach_header_32_t *pHdr, PRTLDRREADER pRdr,
+                                            RTFOFF offImage, uint32_t fOpenFlags, uint32_t *pcSegments, uint32_t *pcSections,
+                                            uint32_t *pcbStringPool, bool *pfCanLoad, PRTLDRADDR pLinkAddress,
+                                            uint8_t *puEffFileType)
 {
     union
@@ -2530,4 +2533,5 @@
  * @returns IPRT status code.
  * @param   pThis           The Mach-O module interpreter instance.
+ * @param   BaseAddress     The module base address.
  * @param   pfnGetImport    The callback for resolving an imported symbol.
  * @param   pvUser          User argument to the callback.
@@ -2679,5 +2683,4 @@
  * @param   pvMapping       The mapping to fixup.
  * @param   NewBaseAddress  The address to fixup the mapping to.
- * @param   OldBaseAddress  The address the mapping is currently fixed up to.
  */
 static int  kldrModMachOObjDoFixups(PKLDRMODMACHO pThis, void *pvMapping, RTLDRADDR NewBaseAddress)