Index: trunk/Config.kmk
===================================================================
--- trunk/Config.kmk	(revision 74651)
+++ trunk/Config.kmk	(revision 74652)
@@ -515,8 +515,4 @@
 # Include the EFI firmware into the package
 VBOX_WITH_EFIFW_PACKING = 1
-# Use kStuff for MACH-O and LX binary loading.
-if1of ($(KBUILD_TARGET_ARCH), x86 amd64)
- IPRT_WITH_KSTUFF = 1
-endif
 # Enable setuid wrapper for Solaris host DVD.
 #VBOX_WITH_SUID_WRAPPER = 1
@@ -6636,8 +6632,4 @@
 TEMPLATE_VBoxAdvBldProg_LIBS    = \
 	$(PATH_STAGE_LIB)/RuntimeBldProg$(VBOX_HOSTSUFF_LIB) \
-	$(if-expr defined(IPRT_WITH_KSTUFF), \
-		$(PATH_STAGE_LIB)/VBox-kStuffStaticBldProg$(VBOX_HOSTSUFF_LIB) \
-		$(PATH_STAGE_LIB)/RuntimeBldProg$(VBOX_HOSTSUFF_LIB) \
-	,) \
 	$(TEMPLATE_VBoxBldProg_LIBS)
 TEMPLATE_VBoxAdvBldProg_LIBS.darwin = \
Index: trunk/Maintenance.kmk
===================================================================
--- trunk/Maintenance.kmk	(revision 74651)
+++ trunk/Maintenance.kmk	(revision 74652)
@@ -30,5 +30,5 @@
 	@$(ECHO) ""
 	@$(ECHO) "up update         - Update svn and fetch tools."
-	@$(ECHO) "up2 update2       - Update svn and fetch tools, ignore externals (kBuild, kStuff)."
+	@$(ECHO) "up2 update2       - Update svn and fetch tools, ignore externals (kBuild)."
 	@$(ECHO) "incs              - Update autogenerated assembly include files in include/."
 	@$(ECHO) "snapshot-puel     - Create a source tarball of the PUEL (closed) sources."
Index: trunk/src/VBox/Runtime/Makefile.kmk
===================================================================
--- trunk/src/VBox/Runtime/Makefile.kmk	(revision 74651)
+++ trunk/src/VBox/Runtime/Makefile.kmk	(revision 74652)
@@ -266,4 +266,5 @@
 	LDR_WITH_ELF32 \
 	LDR_WITH_LX \
+	LDR_WITH_MACHO \
 	LDR_WITH_PE \
 	RT_WITH_VBOX \
@@ -272,7 +273,4 @@
 	IPRT_WITH_OPENSSL \
 	NOFILEID
-ifeq ($(USERNAME),bird)
- RuntimeR3_DEFS += LDR_WITH_MACHO
-endif
 if1of ($(KBUILD_TARGET_ARCH), amd64 x86)
  RuntimeR3_DEFS         += \
@@ -280,7 +278,4 @@
 endif
 #RuntimeR3_DEFS         += RTMEM_WRAP_TO_EF_APIS
-ifdef IPRT_WITH_KSTUFF
- RuntimeR3_DEFS        += LDR_WITH_KLDR
-endif
 ifdef IPRT_WITH_LZJB
  RuntimeR3_DEFS        += RTZIP_USE_LZJB
@@ -300,8 +295,4 @@
 RuntimeR3_INCS         += \
 	$(PATH_ROOT)/src/libs/liblzf-3.4
-ifdef IPRT_WITH_KSTUFF
- RuntimeR3_INCS        += \
-	$(PATH_ROOT)/src/libs/kStuff/kStuff/include
-endif
 
 # RuntimeR3_INCS.solaris  = \
@@ -797,9 +788,4 @@
 
 
-ifdef IPRT_WITH_KSTUFF
- RuntimeR3_SOURCES += \
-	common/ldr/ldrkStuff.cpp
-endif
-
 # VBox specific stuff.
 RuntimeR3_SOURCES += \
@@ -1630,5 +1616,4 @@
 	common/ldr/ldrEx.cpp \
 	common/ldr/ldrFile.cpp \
-	common/ldr/ldrkStuff.cpp \
 	common/ldr/ldrLX.cpp \
 	common/ldr/ldrMachO.cpp \
@@ -1990,5 +1975,4 @@
 RuntimeGuestR3_INCS.$(KBUILD_HOST)      := $(RuntimeR3_INCS.$(KBUILD_HOST))
 RuntimeGuestR3_SOURCES                  := $(filter-out \
-	common/ldr/ldrkStuff.cpp \
 	common/time/timesupref.cpp \
 	common/time/timesupA.asm \
@@ -2139,8 +2123,4 @@
 	$(PATH_STAGE_LIB)/SUPR3$(VBOX_SUFF_LIB)
 endif
-ifdef IPRT_WITH_KSTUFF
- VBoxRT_LIBS                  += \
-	$(PATH_STAGE_LIB)/VBox-kStuff$(VBOX_SUFF_LIB)
-endif
 ifndef SDK_VBOX_LIBXML2_LIBS
  VBoxRT_LIBS                 += \
@@ -2292,8 +2272,4 @@
 VBoxRT-x86_LIBS += \
 	$(PATH_STAGE_LIB)/SUPR3-x86$(VBOX_SUFF_LIB)
-endif
-ifdef IPRT_WITH_KSTUFF
- VBoxRT-x86_LIBS                  += \
-	$(PATH_STAGE_LIB)/VBox-kStuff-x86$(VBOX_SUFF_LIB)
 endif
 ifndef SDK_VBOX_LIBXML2_LIBS
@@ -3626,5 +3602,4 @@
 		'$(VBOX_PATH_RUNTIME_SRC)/common/string/unidata-lower.cpp' \
 		'$(VBOX_PATH_RUNTIME_SRC)/common/string/unidata-upper.cpp' \
-		'$(VBOX_PATH_RUNTIME_SRC)/common/ldr/ldrkStuff.cpp'
 	$(QUIET)$(APPEND) $@.tmp
 	$(QUIET)$(APPEND) $@.tmp 'INPUT = $(foreach x,$(IPRT_DOXYFILE_INPUT),\$(NLTAB)$(x))'
Index: trunk/src/VBox/ValidationKit/Config.kmk
===================================================================
--- trunk/src/VBox/ValidationKit/Config.kmk	(revision 74651)
+++ trunk/src/VBox/ValidationKit/Config.kmk	(revision 74652)
@@ -71,9 +71,4 @@
 TEMPLATE_VBoxValidationKitR3_LIBS = \
 	$(PATH_STAGE_LIB)/RuntimeR3$(VBOX_SUFF_LIB)
-ifdef IPRT_WITH_KSTUFF
- TEMPLATE_VBoxValidationKitR3_LIBS += \
- 	$(PATH_STAGE_LIB)/VBox-kStuffStatic$(VBOX_SUFF_LIB) \
- 	$(PATH_STAGE_LIB)/RuntimeR3$(VBOX_SUFF_LIB)
-endif
 ifeq ($(KBUILD_TARGET),solaris)
  TEMPLATE_VBoxValidationKitR3_LIBS += \
@@ -130,9 +125,4 @@
 	$(PATH_STAGE_LIB)/SUPR3Static$(VBOX_SUFF_LIB) \
 	$(PATH_STAGE_LIB)/RuntimeR3$(VBOX_SUFF_LIB)
-ifdef IPRT_WITH_KSTUFF
- TEMPLATE_VBoxValidationKitR3Host_LIBS += \
- 	$(PATH_STAGE_LIB)/VBox-kStuffStatic$(VBOX_SUFF_LIB) \
- 	$(PATH_STAGE_LIB)/RuntimeR3$(VBOX_SUFF_LIB)
-endif
 ifeq ($(KBUILD_TARGET),solaris)
  TEMPLATE_VBoxValidationKitR3Host_LIBS += \
Index: trunk/src/libs/Makefile.kmk
===================================================================
--- trunk/src/libs/Makefile.kmk	(revision 74651)
+++ trunk/src/libs/Makefile.kmk	(revision 74652)
@@ -51,9 +51,4 @@
 endif
 
-# The kStuff lib used by IPRT and the debugger.
-if defined(IPRT_WITH_KSTUFF)
- include $(PATH_SUB_CURRENT)/kStuff/Makefile.kmk
-endif
-
 # OpenSSL.
 if  !defined(VBOX_ONLY_SDK) \